package com.cttic.tcpreceive.rocket;


import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.producer.SendCallback;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class RocketProducer {

  @Resource
  RocketMQTemplate template;


  public void sendMessage(String topic, String msg) {
    this.template.convertAndSend(topic, msg);
  }


  public void sendMessageAsync(String topic,String msg) {
    this.template.asyncSend(topic, msg, new SendCallback() {
      @Override
      public void onSuccess(SendResult sendResult) {
        log.info("发送成功");
      }

      @Override
      public void onException(Throwable throwable) {
        log.error("发送失败");
      }
    });
  }
}
