package com.cttic.tcpreceive.service;



import com.alibaba.fastjson.JSONObject;
import com.cttic.tcpreceive.domain.TcpEntity;
import com.cttic.tcpreceive.domain.TcpEntityHistory;
import com.cttic.tcpreceive.domain.ZjdsjShipInfo;

import com.cttic.tcpreceive.rocket.RocketProducer;
import com.cttic.tcpreceive.utils.CoordinateUtils;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Objects;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.BeanUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * @author gengaoliu
 */
@Service
@Slf4j
public class TcpTest{

    @Resource
    private RedisTemplate<String, Object> redisTemplate;

    @Resource
    private RocketProducer producer;


    public void analysis(String lastEnd, String s) throws Exception {
        try {
             execute(lastEnd, s);
        } catch (Exception e) {
            log.error("报错:{}，但是继续执行",e.getMessage());
        }

    }

    private void execute(String lastEnd, String s) throws Exception {
        String head;
        String end;
        if (!s.contains("login") && StringUtils.hasText(s)) {
//            log.error(s + "-------------");
            s = s.replaceAll("\r", "");
            ArrayList<TcpEntity> tcpEntities = new ArrayList<>();
            ArrayList<TcpEntityHistory> tcpEntityHistories = new ArrayList<>();
            ArrayList<ZjdsjShipInfo> zjdsjShipInfos = new ArrayList<>();
            String[] p_s1 = (s).replace("p ", "p~").split("~");
            if (p_s1.length == 14 || p_s1.length == 20)
                handleMethod2(tcpEntities,tcpEntityHistories,zjdsjShipInfos,p_s1);
//            String[] p_s = s.split("p");
//            head = p_s[0];
//            if (s.endsWith("p")) {
//                end = "p";
//            }else {
//                end ="p" +  p_s[p_s.length-1];
//            }
//            if (p_s.length>1) {
//                p_s = Arrays.copyOfRange(p_s, 1, p_s.length - 1, String[].class);
//                for (String p_ : p_s) {
//                    String[] p_s1 = ("p" + p_).replace("p ", "p~").split("~");
//                    if (p_s1.length == 14 || p_s1.length == 20)
//                        handleMethod2(s, tcpEntities,tcpEntityHistories,zjdsjShipInfos,p_s1);
//                }
//            }
//            String[] p_s1 = (lastEnd + head).replace("p ", "p~").split("~");
//            if (p_s1.length == 14 || p_s1.length == 20)
//                handleMethod2(s, tcpEntities,tcpEntityHistories,zjdsjShipInfos,p_s1);
//            if (saveData) {
//                log.info("tcpEntities 大小为:{}",tcpEntities.size());
//                log.info("tcpEntityHistories 大小为:{}",tcpEntityHistories.size());
//                log.info("zjdsjShipInfos 大小为:{}",zjdsjShipInfos.size());
//                ResultState resultState = aisBcwDubboApi.save(tcpEntities, tcpEntityHistories,
//                    zjdsjShipInfos);
//                if (resultState.equals(ResultState.SUCCESS)) {
//                    Date date = new Date();
//                    System.out.println((date.getTime() - date1.getTime()) + "-----");
//                    log.warn("存储成功  NOW TIME：{}", DateUtils.dateToString(date,"yyyy-MM-dd HH:mm:ss"));
//                }else {
//                    log.error("远程服务器出现问题，存储失败");
//                }
//            }
//            lastEnd = end;
        }
    }

    private void handleMethod2(ArrayList<TcpEntity> tcpEntities, ArrayList<TcpEntityHistory> tcpEntityHistories, ArrayList<ZjdsjShipInfo> zjdsjShipInfos, String[] split1) throws Exception{
//        log.error(Arrays.toString(split1));
        TcpEntity tcpEntity = new TcpEntity();
        tcpEntity.setP(split1[0].trim());
        tcpEntity.setMmsi(split1[1].trim());
        tcpEntity.setRot(split1[2].trim());
        tcpEntity.setClassType(split1[3].trim());
//        if (!org.springframework.util.StringUtils.hasText(split1[4].trim())) {
//            log.warn(s);
//        } else {
            long date = Long.parseLong(split1[4].trim()) * 1000;
//            long date = BigDecimal.valueOf(Long.parseLong(split1[4].trim()))
//                .multiply(BigDecimal.valueOf(1000)).longValue();
            tcpEntity.setPositionTime(new Date(date));
//        }
        if (!StringUtils.hasText(split1[6].trim()) || !StringUtils.hasText(split1[5].trim())) {
//            log.warn(s);
        } else {
            try {
            tcpEntity.setLat(new BigDecimal(Double.parseDouble(split1[6].trim()) / 600000).setScale(3, BigDecimal.ROUND_HALF_UP).doubleValue());
            tcpEntity.setLon(new BigDecimal(Double.parseDouble(split1[5].trim()) / 600000).setScale(3, BigDecimal.ROUND_HALF_UP).doubleValue());
            double[] doubles = CoordinateUtils.gps84_To_SHXY(tcpEntity.getLon(), tcpEntity.getLat());
                tcpEntity.setMapx(new BigDecimal(doubles[0]).setScale(3, BigDecimal.ROUND_HALF_UP).doubleValue());
                tcpEntity.setMapy(new BigDecimal(doubles[1]).setScale(3, BigDecimal.ROUND_HALF_UP).doubleValue());
            }catch (Exception e) {
                log.error("本次信令为：{}", Arrays.toString(split1));
                log.error(e.getMessage());
                return;
            }
        }
        if (!StringUtils.hasText(split1[7].trim())) {
//            log.warn(s);
        } else {
            tcpEntity.setCourse(Double.parseDouble(split1[7].trim()) / 10);
        }
        tcpEntity.setHeading(split1[8].trim());
        if (!StringUtils.hasText(split1[9].trim())) {
//            log.warn(s);
        } else {
            tcpEntity.setSpeed(Double.parseDouble(split1[9].trim()) / 10);
        }
        tcpEntity.setStatus(split1[10].trim());
        tcpEntity.setAccuracy(split1[11].trim());
        if (!StringUtils.hasText(split1[12].trim())) {
//            log.warn(s);
        } else {
            tcpEntity.setReceiveTime(new Date(Long.parseLong(split1[12].trim()) * 1000));
        }
        tcpEntity.setSourceId(split1[13].trim());
//        tcpEntities.add(tcpEntity);
        producer.sendMessage("bcwrealtime", JSONObject.toJSONString(tcpEntity));
        if (split1.length == 20) {
            ZjdsjShipInfo zjdsjShipInfo = new ZjdsjShipInfo();
            zjdsjShipInfo.setMmsi(tcpEntity.getMmsi());
            if (!StringUtils.hasText(split1[14].trim())) {
//                log.warn(s);
            } else {
                zjdsjShipInfo.setBreadth(Double.parseDouble(split1[14].trim()));
            }
            zjdsjShipInfo.setCallSign(split1[15].trim());
            if (!StringUtils.hasText(split1[16].trim())) {
//                log.warn(s);
            } else {
                zjdsjShipInfo.setImo(Integer.parseInt(split1[16].trim()));
            }
            if (!StringUtils.hasText(split1[17].trim())) {
//                log.warn(s);
            } else {
                zjdsjShipInfo.setLength(Double.parseDouble(split1[17].trim()));
            }
            zjdsjShipInfo.setShipName(split1[18].trim());
            zjdsjShipInfo.setUpdateTime(new Date());
            if (!StringUtils.hasText(split1[19].trim())) {
//                log.warn(s);
            } else {
                if (Integer.parseInt(split1[19].trim().substring(0,1).trim()) == 0) {
                    zjdsjShipInfo.setShipType(0);
                }else {
                 zjdsjShipInfo.setShipType(Integer.parseInt(split1[19].trim().substring(0,2).trim()));
                }
            }
//            zjdsjShipInfos.add(zjdsjShipInfo);
            producer.sendMessage("shipinfo", JSONObject.toJSONString(zjdsjShipInfo));
        }
        TcpEntityHistory tcpEntityHistory = new TcpEntityHistory();
        BeanUtils.copyProperties(tcpEntity, tcpEntityHistory);
        if (!Objects.equals(redisTemplate.opsForHash().get("ZJDSJ", tcpEntityHistory.getMmsi()), tcpEntityHistory)) {
//            tcpEntityHistories.add(tcpEntityHistory);
            producer.sendMessage("bcwhistory", JSONObject.toJSONString(tcpEntityHistory));
            redisTemplate.opsForHash().put("ZJDSJ", tcpEntityHistory.getMmsi(), tcpEntityHistory);
        }
    }
}